



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C#遍历指定路径下的目录</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C#遍历指定路径下的目录</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-12 23:44:06 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>通过指定路径訪问路径下的文件。在C#的开发中主要利用了Directory类和DirectoryInfo类，简要介绍Directory类中的成员：命名空间</p>
<div>System.IO 命名空间</div>
<p>1、<a href="" rel="external nofollow noreferrer">CreateDirectory</a>。已重载，用于创建指定路径下的全部文件夹。</p>
<p>2、<a href="" rel="external nofollow noreferrer">Delete</a>，删除指定文件夹。</p>
<p>3、<a href="" rel="external nofollow noreferrer">Exists</a>，确定给定文件夹是否引用磁盘现有文件夹；说白点就是推断路径是否存在；</p>
<p>4、<a href="" rel="external nofollow noreferrer">GetCreationTime</a>，获取文件夹的创建时间和日期；</p>
<p>4、<a href="" rel="external nofollow noreferrer">GetCurrentDirectory</a>，获取应用程序的当前文件夹；</p>
<p>5、<a href="" rel="external nofollow noreferrer">GetDirectories</a>。获取指定文件夹下子文件夹的名称。返回&#20540;是一个字符串数组。</p>
<p>6、<a href="" rel="external nofollow noreferrer">GetFiles</a>。获取指定路径下的文件名；</p>
<p>7、<a href="" rel="external nofollow noreferrer">GetFileSystemEntries</a>，获取指定路径下全部文件和子文件夹的名称；</p>
<p>8、<a href="" rel="external nofollow noreferrer">GetParent</a>。获取指定路径的父文件夹；</p>
<p>9、<a href="" rel="external nofollow noreferrer">Move</a>，将文件或文件夹移动到新位置；</p>
<p>（2）简要介绍下DirectoryInfo类的成员：</p>
<p>1、<a href="" rel="external nofollow noreferrer">Create</a>，创建指定文件夹；</p>
<p>2、<a href="" rel="external nofollow noreferrer">Delete</a>，从路径中删除DirectoryInfo和其内容</p>
<p>3、<a href="" rel="external nofollow noreferrer">GetDirectories</a>，获取当前文件夹的子文件夹；</p>
<p>4、<a href="" rel="external nofollow noreferrer">GetFiles</a>。获取当前文件夹下的文件列表；返回<a href="" rel="external nofollow noreferrer">FileInfo</a>[]类型的数组；</p>
<p>5、<a href="" rel="external nofollow noreferrer">MoveTo</a>，将<br />
<a href="" rel="external nofollow noreferrer">DirectoryInfo</a> 实例及其内容移动到新路径。</p>
<p>代码实现：</p>
<p><pre class="prettyprint linenums">         /// &lt;summary&gt;<br />
        /// 打开文件<br />
        /// &lt;/summary&gt;<br />
        private void bePath_Click(object sender, EventArgs e)<br />
        {<br />
            this.MenuList.Nodes.Clear();<br />
            FolderBrowserDialog folderBrowserDialog = new FolderBrowserDialog();<br />
            folderBrowserDialog.Description = &quot;请选择文件夹：&quot;;<br />
            if (folderBrowserDialog.ShowDialog() == DialogResult.OK)<br />
            {<br />
                sPath = folderBrowserDialog.SelectedPath;<br />
            }

            if (!string.IsNullOrEmpty(sPath))<br />
            {<br />
                this.bePath.Text = sPath;<br />
                TreeListNode ParentNode = this.MenuList.AppendNode(new object[] { sPath }, -1);<br />
                GetSubFile(sPath, ParentNode);<br />
                GetSubRoot(sPath, ParentNode);<br />
            }<br />
        }
</pre>

<pre class="prettyprint linenums">        /// &lt;summary&gt;<br />
        /// 获取路径的集合<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name=&quot;sPath&quot;&gt;&lt;/param&gt;<br />
        private void GetSubRoot(string sFilePath, TreeListNode ParentNode)<br />
        {<br />
            if (string.IsNullOrEmpty(sFilePath))<br />
            {<br />
                return;<br />
            }

            string[] DirectoryList = Directory.GetDirectories(sFilePath);<br />
            foreach (string sDirectory in DirectoryList)<br />
            {<br />
                ParentNode = this.MenuList.AppendNode(new object[] { sDirectory }, ParentNode);<br />
                GetSubFile(sDirectory,ParentNode);<br />
                GetSubRoot(sDirectory,ParentNode);<br />
            }<br />
        }</pre>

<pre class="prettyprint linenums">        /// &lt;summary&gt;<br />
        /// 获取路径下的文件<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name=&quot;sSubRootPath&quot;&gt;&lt;/param&gt;<br />
        /// &lt;param name=&quot;ParentNode&quot;&gt;&lt;/param&gt;<br />
        private void GetSubFile(string sSubRootPath, TreeListNode ParentNode)<br />
        {<br />
            FileInfo[] ArrayileInfo;

            DirectoryInfo pDirectoryInfo = new DirectoryInfo(sSubRootPath);<br />
            ArrayileInfo = pDirectoryInfo.GetFiles(&quot;*.&quot;);<br />
            if (ArrayileInfo.Length &lt; 1)<br />
            {<br />
                return;<br />
            }

            foreach (FileInfo pFileInfo in ArrayileInfo)<br />
            {<br />
                string sName = pFileInfo.Name;<br />
                MenuList.AppendNode(new object[] { sName }, ParentNode);<br />
            }<br />
        }</pre></p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141024142549271?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvYW5saWRlbmdzaGl3ZWk=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center"></p>
<pre class="prettyprint linenums">
</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqllo60q.html">MySQL InnoDB存储引擎</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pp75d9.html">Java中怎么切换窗口</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxoyljq.html">002：IPC与system函数简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z5g1v8.html">Java实现队列</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z5vg18.html">Android shell 命令总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1463x9.html">如何使用工具进行线上 PHP 性能追踪及分析？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdelro09.html">javaweb 之javascript 结合</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1gr6j9.html">【科研论文】W5100在远程电力质量监测设备中的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1rlgk8.html">jasmine note</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgdgd78.html">编写自定义的JDBC框架与策略模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzlv6e8.html">hashcode-equals方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge6kz08.html">python pickle 模块的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pwp3y8.html">shell中的wait</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1mm22q.html">Python基础之迭代器和生成器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy4oxgq.html">Ganglia 入门介绍及解决fsockopen error&colon; Connection refused问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1l6kl9.html">JavaScricp（总回顾）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll2joxq.html">常用linux命令（项目部署）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvgyor8.html">meta标签常用设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j0o7jq.html">Centos7部署ntp服务器同步时间以及直接将本地时间同步为北京时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1e2jk9.html">&period;Net Core WebApi控制器接收原始请求正文内容</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mdge328.html">iOS自定义控件创建原理（持续更新）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qloyjyxq.html">Ambari API 验证方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy2p1ej9.html">Spring aop报错：com&period;sun&period;proxy&period;&dollar;Proxyxxx cannot be cast to yyy</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxl1d5zq.html">nginx通过spawn-fcgi调用C&plus;&plus;写的cgi程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/qloylzkq.html">&lbrack;AGC004D&rsqb; Teleporter &lbrack;贪心&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e0d05mq.html">PE第n弹</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kmwmgj9.html">平滑升级nginx</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2xrmw39.html">理解exports</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r4o0lm8.html">FOR XML PATH 语句的应用【所有列值显示在一行中】</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnd3yo38.html">PE笔记之PE文件总览图</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
